#ifndef __PICT_H__
#define __PICT_H__
#include "bitmap.h"
#include "common.h"


#define SCREEN_SHOT_BUFFER_SIZE (SCREEN_SHOT_WIDTH*SCREEN_SHOT_HEIGHT*2)
#define SCREEN_SHOT_WIDTH (480 / 2)
#define SCREEN_SHOT_HEIGHT (272 / 2)
#define SCREEN_SHOT_DATA_NUM (18)

typedef struct PictData_{
	void *raw;
	u32 size;
	u32 width;
	u32 height;
}PictData;

typedef struct PictInfo_ {
	PictData data;
	int memid;
}PictInfo;

typedef struct SSData_{
	void *raw;
	u32 size;
	u32 width;
	u32 height;
	u32 pixel_format;
}SSData;


int loadBmp(const char *path, PictData *data);
int takeScreenShot(const char *path);
void drawPict5551(int x, int y, PictData *data);
void drawPict(int x, int y, PictData *data);

void *kalloc(SceSize size, const char *name, int *id, int part, int type);
inline void kfree(int id);
void *kalloc_volatile();
inline void kfree_volatile();
void *allocScreenShotBufferMemory(SceSize size, int *id);

//inline void changeFormatToBmpFormat(char *str);
void loadScreenShot(PictData *data, int savetype, int slot_pos);
int takeScreenShotforBuffer(SSData *data);
void drawPictFromBuf(int x, int y, SSData *data);


// define
#define RGB(r, g, b)			 ((r) | ((g) << 8) | ((b) << 16))
#define RGB_8888(r, g, b)	(u32)((r) | ((g) << 8) | ((b) << 16))
#define RGB_565(r, g, b)	(u16)((r) | ((g) << 5) | ((b) << 11))
#define RGB_5551(r, g, b)	(u16)((r) | ((g) << 5) | ((b) << 10))
#define RGB_4444(r, g, b)	(u16)((r) | ((g) << 4) | ((b) <<  8))


__inline u16 convert_8888_to_5551(u32 color);
__inline u16 convert_u32_to_u16(u32 color, int pixelformat);


extern PictInfo screenShotInfo[SCREEN_SHOT_DATA_NUM];
extern PictInfo restoreInfo[2];

int convertAndRescaleTo5551(void *inRaw, u32 inWidth, u32 inHeight, void *outRaw, u32 outWidth, u32 outHeight);

#endif
