//Thanks hiroi01

#include <pspkernel.h>
#include <pspdisplay.h>
#include "pict.h"


PictInfo screenShotInfo[SCREEN_SHOT_DATA_NUM];

//thanks to libmenu by maxem

inline u32 libmConvert4444_8888(u32 src)
{
	return ((src & 0xf000) << 28) | ((src & 0xf000) << 24) | ((src & 0x0f00) << 20) | ((src & 0x0f00) << 16) | ((src & 0x00f0) << 12) | ((src & 0x00f0) << 8 ) | ((src & 0x000f) << 4 ) | ((src & 0x000f) << 0 );
}

inline u32 libmConvert5551_8888(u32 src)
{
	return ((src & 0x8000) << 16) | ((src & 0x8000) << 15) | ((src & 0x8000) << 14) | ((src & 0x8000) << 13) | ((src & 0x8000) << 12) | ((src & 0x8000) << 11) | ((src & 0x8000) << 10) | ((src & 0x8000) << 9) |
	((src & 0x7c00) << 9) | ((src & 0x7000) << 4) | ((src & 0x03e0) << 6) | ((src & 0x0380) << 1) | ((src & 0x001f) << 3) | ((src & 0x001c) >> 2);
}

inline u32 libmConvert5650_8888(u32 src)
{
	return 0xff000000 | ((src & 0xf800) << 8) | ((src & 0xe000) << 3) | ((src & 0x07e0) << 5) | ((src & 0x0600) >> 1) | ((src & 0x001f) << 3) | ((src & 0x001c) >> 2);
}
inline u32 libmConvert8888_5650( u32 src )
{
	return ((src & 0x00f80000) >> 8) | ((src & 0x0000fc00) >> 5) | ((src & 0x000000f8) >> 3);
}

inline u32 libmConvert8888_5551( u32 src )
{
	return (( ( src >> 24 ) ? 1 : 0 ) << 15) | ((src & 0x00f80000) >> 9 ) | ((src & 0x0000f800) >> 6 ) | ((src & 0x000000f8) >> 3 );
}

inline u32 libmConvert8888_4444( u32 src )
{
	return ((src & 0xf0000000) >> 16) | ((src & 0x00f00000) >> 12) | ((src & 0x0000f000) >> 8 ) | ((src & 0x000000f0) >> 4 );
}

inline u32 libmConvert5551_5650( u32 src )
{
	return libmConvert8888_5650(libmConvert5551_8888(src));
}

inline u32 libmConvert5551_4444( u32 src )
{
	return libmConvert8888_4444(libmConvert5551_8888(src));
}



void drawPict5551(int x, int y, PictData *data)
{
	u32 *vram32, *vram32_ptr;
	u16 *vram16, *vram16_ptr;
	int i, j, count;
	u16 *raw16 = (u16 *)data->raw;

	int unk = 0;

	// ʏ̎擾
	sceDisplayGetMode(&unk, &canvas.width, &canvas.height);
	sceDisplayGetFrameBuf((void *)&canvas.buffer, &canvas.linewidth, &canvas.pixelformat, 1);

	
	count = 0;
	switch(canvas.pixelformat)
	{
		case PSP_DISPLAY_PIXEL_FORMAT_5551:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++)
					*vram16_ptr = raw16[count++];
				
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}			
		case PSP_DISPLAY_PIXEL_FORMAT_8888:
		{
			vram32 = canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram32_ptr = vram32;
				
				for(i = 0; i < data->width; i++, vram32_ptr++)
					*vram32_ptr = libmConvert5551_8888(raw16[count++]);
				
				vram32 += canvas.linewidth;
			}
			
			break;
		}
		case PSP_DISPLAY_PIXEL_FORMAT_565:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++){
					*vram16_ptr = libmConvert5551_5650(raw16[count++]);
				}
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}
		case PSP_DISPLAY_PIXEL_FORMAT_4444:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++)
					*vram16_ptr = libmConvert5551_4444(raw16[count++]);
				
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}
	}
	return;
	
}


/*
void drawPictFromBuf(int x, int y, SSData *data)
{
	u32 *vram32, *vram32_ptr;
	u16 *vram16, *vram16_ptr;
	int i, j, count;
	u16 *raw16 = (u16 *)data->raw;
	u16 *raw32 = (u32 *)data->raw;

	int unk = 0;

	// ʏ̎擾
	sceDisplayGetMode(&unk, &canvas.width, &canvas.height);
	sceDisplayGetFrameBuf((void *)&canvas.buffer, &canvas.linewidth, &canvas.pixelformat, 1);

//	sceDisplaySetFrameBuf((void *)data->raw, canvas.linewidth, canvas.pixelformat, 1);

	
	count = 0;
	switch(canvas.pixelformat)
	{
		case PSP_DISPLAY_PIXEL_FORMAT_5551:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++)
					*vram16_ptr = raw16[count++];
				
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}			
		case PSP_DISPLAY_PIXEL_FORMAT_8888:
		{
			vram32 = canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram32_ptr = vram32;
				
				for(i = 0; i < data->width; i++, vram32_ptr++)
					*vram32_ptr = libmConvert5551_8888(raw16[count++]);
				
				vram32 += canvas.linewidth;
			}
			
			break;
		}
		case PSP_DISPLAY_PIXEL_FORMAT_565:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++){
					*vram16_ptr = libmConvert5551_5650(raw16[count++]);
				}
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}
		case PSP_DISPLAY_PIXEL_FORMAT_4444:
		{
			vram16 = (u16 *)canvas.buffer + x + y * canvas.linewidth;
			
			for(j = 0; j < data->height; j++)
			{
				vram16_ptr = vram16;
				
				for(i = 0; i < data->width; i++, vram16_ptr++)
					*vram16_ptr = libmConvert5551_4444(raw16[count++]);
				
				vram16 += canvas.linewidth;
			}
			
			
			break;
		}
	}
	return;
	
}
*/

