
#include "common.h"
#include "states.h"

extern char prxPath[];
extern char number_txt[];
extern char gameid[];
extern char states_str[];
extern char gamepath[];
extern int states_color[];


int setDate(char *time_str, ScePspDateTime time) {
	sprintf(time_str,"%u/%u/%u %u:%02u:%02u", time.year, time.month, time.day, time.hour, time.minute, time.second);
	return 0;
}

char *changeFormatToBmpFormat(const char *before, char *after)
{
	strcpy(after, before);
	char *end = strchr(after, '\0');
	end[-3] = 'b';
	end[-2] = 'm';
	end[-1] = 'p';

	return after;
}


char *makePath(char *path, char *name)
{
	char buf[256];
	strcpy(buf, prxPath);
	strcat(buf, "/SAVESTATE/");
	strcat(buf, name);
	strcat(buf, ".bin");
	strcpy(path, buf);
	return path;
}


void statesGameId(char *buf)
{
	char *ptr, *id_start;

	if(sceKernelBootFrom() == PSP_BOOT_MS)
	{
		ptr = strrchr(gamepath, '/');
		*ptr = '\0';

		id_start = strrchr(gamepath, '/');
		strncpy(buf, id_start + 1, 9);

		buf[9] = '\0';
		*ptr = '/';
	}
	else 
	{
		strcpy(buf, gameid);
	}
}


void checkBin(PspStates states[], char *statesid)
{
	int i,j;
	char buf[512];
	SceIoStat stat;

	strcpy(states[0].id, statesid);
	strcpy(states[1].id, "globalstate");
	
	for(j=0; j<2; j++){
		for(i=0; i<9; i++){
			sprintf(states[j].bin[i].name, "%s_%c", states[j].id, number_txt[i]);
			strcpy(states[j].bin[i].path, makePath(buf, states[j].bin[i].name));
			int ret = sceIoGetstat(states[j].bin[i].path, &stat);
			if(ret == 0){
				states[j].bin[i].flag = true;
				setDate(buf, stat.st_mtime);
			}else if(ret < 0){
				states[j].bin[i].flag = false;
				strcpy(buf, "NOT FOUND");
			}
			sprintf(states[j].bin[i].menu_str, (j ? "%s - %s" : "%s   - %s"), states[j].bin[i].name, buf);
		}
	}
}
